# ----------------------------------------------------------------------
# LALSuite: compiler tests
#
# Top-level build tests for various non-default compilers.
# ----------------------------------------------------------------------

.compiler-test:
  stage: compiler tests
  needs: []
  extends:
    - .make-distcheck
  rules:
    - !reference [.ci-compiler, rules]
    - !reference [.ci-merge-build, rules]

clang:12:
  extends:
    - .compiler-test
  image: igwn/lalsuite-dev-clang:12
  variables:
    CC: clang-12
    CXX: clang++-12

clang:13:
  extends:
    - .compiler-test
  image: igwn/lalsuite-dev-clang:13
  variables:
    CC: clang-13
    CXX: clang++-13

clang:14:
  extends:
    - .compiler-test
  image: igwn/lalsuite-dev-clang:14
  variables:
    CC: clang-14
    CXX: clang++-14

clang:15:
  extends:
    - .compiler-test
  image: igwn/lalsuite-dev-clang:15
  variables:
    CC: clang-15
    CXX: clang++-15

clang:dev:
  extends:
    - .compiler-test
  image: igwn/lalsuite-dev-clang:dev
  variables:
    CC: clang
    CXX: clang++

.compiler-test:gcc:
  extends:
    - .compiler-test
  variables:
    CONFIGURE_FLAGS: "--enable-doxygen --enable-swig --enable-python --disable-swig-octave"

gcc:7:
  extends:
    - .compiler-test:gcc
  image: igwn/lalsuite-dev-gcc:7

gcc:8:
  extends:
    - .compiler-test:gcc
  image: igwn/lalsuite-dev-gcc:8

gcc:9:
  extends:
    - .compiler-test:gcc
  image: igwn/lalsuite-dev-gcc:9

gcc:10:
  extends:
    - .compiler-test:gcc
  image: igwn/lalsuite-dev-gcc:10

gcc:11:
  extends:
    - .compiler-test:gcc
  image: igwn/lalsuite-dev-gcc:11

gcc:12:
  extends:
    - .compiler-test:gcc
  image: igwn/lalsuite-dev-gcc:12

cuda:
  extends:
    - .compiler-test
  image: igwn/lalsuite-dev-cuda:el7
  script:
    - ./00boot
    # test ./configure works with non-system CUDA install path
    - rm -f $PWD/gitlab-ci-non-sys-cuda-path
    - ln -s /usr/local/cuda $PWD/gitlab-ci-non-sys-cuda-path
    - ./configure --with-cuda=$PWD/gitlab-ci-non-sys-cuda-path
    - rm -f $PWD/gitlab-ci-non-sys-cuda-path
    # test ./configure works with system CUDA install path
    - ./configure --with-cuda=/usr/local/cuda
    # check compilation and tarball
    - make -j${CPU_COUNT} dist
    - make -j${CPU_COUNT}
    # just compile test suite; some tests require a CUDA device to run
    - make -j${CPU_COUNT} VERBOSE=1 check TESTS=
    - make -j${CPU_COUNT} install
  artifacts:
    # we don't run the test suite, so there are no reports
    reports:
      junit: []

icc:
  extends:
    - .compiler-test
  image: igwn/lalsuite-dev-icc:el7
  variables:
    CONFIGURE_FLAGS: "--enable-doxygen --enable-swig --enable-python --disable-swig-octave --disable-static --enable-intelfft"
